# -*- coding: utf-8 -*-
"""
Created on Fri Jan 25 18:19:31 2019

@author: Derin
"""

#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Jan 18 14:18:44 2019

@author: Derin
"""
# Derin's imports (plus numpy)
import cv2
import math
import collections
import sys

# Amir's imports
import tensorflow as tf
import scipy.stats as st
import numpy as np
import time
import glob
from skimage.io import imread
from skimage.color import rgb2gray
import numpy as np
from scipy.ndimage import gaussian_filter
import matplotlib.pyplot as plt
#from tqdm import tqdm_notebook as tqdm
from scipy.signal import medfilt



# Function for collecting radon data from 4D Tensor
def getRadon(radonTensor, angle, row, col, windowSize):
    angle = round(angle)
    returnArr = np.zeros([4, windowSize])
    
    
    ##ASSUME ALL ANGLES FOR NOW
    if angle <0:
        angle += 180
    #     for i in range(4):
    #         newangle = angle + i*45
            
    #         if newangle >= 180:
    #             newangle -= 180
            
    #         radonStartingIndex = int(newangle*windowSize);
    #         radonEndingIndex = radonStartingIndex + 11
    # #        print(radonStartingIndex)
    # #        print(radonTensor.shape)
    #         returnArr[i, :] = radonTensor[0, row,col, radonStartingIndex:radonEndingIndex]
    
    for i in range(4):
        if i == 3:
            newangle = angle + 125
        else:
            # KEEP THIS AND REMOVE THE ABOVE IF DESIRED
            newangle = angle + i*45


        
        if newangle >= 180:
            newangle -= 180
        
        radonStartingIndex = int(newangle*windowSize);
        radonEndingIndex = radonStartingIndex + windowSize
#        print(radonStartingIndex)
#        print(radonTensor.shape)
        returnArr[i, :] = radonTensor[0, row,col, radonStartingIndex:radonEndingIndex]
    
    return returnArr


# Takes the gradient of the arr, takes another gradient of the result, and then converts to binary and then to decimal.
def doubleGradBinarize(arr, cols):
    #Size 4 x cols
    
    returnArr = [0,0,0,0]
    returnNum = 0
    currNum = 0
    #TODO: MIGHT BE OFF BY 1
    for i in range(4):
        returnNum = 0
        for j in range(cols-2):
            # Double gradient
            currNum = arr[i,j] - 2*arr[i, j+1] + arr[i,j+2]
            if currNum > 0:
                currNum = 1
            else:
                currNum = 0
            # Conversion to binary
            returnNum = returnNum + (currNum * 2**(j))
        

        
        returnArr[i] = returnNum
        
    
    return returnArr

def addToBins(bins, addArr, detach=False):
    #bins is orderedDict

    if (detach):
        count = 0
        for item in addArr:
            addNum = 256*count
            if item not in bins:
                bins[addNum + item] = 1
            else:
                bins[addNum + item] +=1
            count+=1
    else:
        for item in addArr:
            if item not in bins:
                bins[item] = 1
            else:
                bins[item] +=1
        
        


# Creates radon transform convolution kernels
def get_kernel(sz, ang):

    bin_ang = np.deg2rad(45. - ang)
    project_length = lambda l, bang: l * np.cos(bang)
    bin_len = project_length(np.sqrt(2)*sz, bin_ang)
    bin_sz = bin_len/(2*sz)
    in_channels = 1
    out_channels = sz
    bin_map = np.zeros( (sz, sz, in_channels, out_channels) )

    for i in range(sz):
        for j in range(sz):

            sub_pixels = np.array([
               [i + 0.25, j + 0.25],
               [i + 0.25, j + 0.75],
               [i + 0.75, j + 0.75],
               [i + 0.75, j + 0.25],
            ])

            pw = 1./len(sub_pixels)
            x = j
            y = sz - i - 1

            for p in sub_pixels:

                theta = np.abs(np.arctan(p[0]/p[1]) - np.deg2rad(ang))
                v = project_length(np.linalg.norm(p), theta)
                bin_idx = int(v//bin_sz)
                diff = v%bin_sz

                if diff < (bin_sz/2 - 0.000001):

                    a = diff/(bin_sz/2)

                    bin_map[x, y, 0, (bin_idx)//2] += pw*a

                    if (bin_idx)//2 != 0:

                        bin_map[x, y, 0, ((bin_idx)//2) - 1] += pw*(1-a)

                    else:

                        bin_map[x, y, 0, (bin_idx)//2] += pw*(1-a)

                elif diff > (bin_sz/2 + 0.000001):

                    a = (diff - (bin_sz/2))/(bin_sz/2)

                    bin_map[x, y, 0, (bin_idx)//2] += pw*a

                    if (bin_idx)//2 != bin_map.shape[0]-1:

                        bin_map[x, y, 0, ((bin_idx)//2) + 1] += pw*(1-a)

                    else:

                        bin_map[x, y, 0, (bin_idx)//2] += pw*(1-a)

                else:

                    bin_map[x, y, 0, (bin_idx)//2] += pw

    return np.array(bin_map)
w = 11

# The below defines the skip amount (0, 91, 10 indicates a step of 10; 0, 91, 30 indicates a step of 30)
kernelStart_time = time.time()
for ang in range(0,91,1):
    k = get_kernel(w, ang)
    if ang == 0:
        r_kernels = k
    else:
        r_kernels = np.concatenate((r_kernels,k),axis=3)

print(r_kernels.shape)
# f_kernels = np.flip(r_kernels,axis=1)
# print(f_kernels.shape)
# f_kernels = np.flip(f_kernels,axis=3)
# print(f_kernels.shape)
# r_kernels = np.concatenate((r_kernels,f_kernels),axis=3)
# print(r_kernels.shape)
# r_kernels = r_kernels[:,:,:,:-w]
# print(r_kernels.shape)
# # r_kernels = r_kernels[:,:,:,:w]
# # print(r_kernels.shape)

f_kernels = np.flip(r_kernels,axis=1)
print(f_kernels.shape)
f_kernels = np.flip(f_kernels,axis=3)


#Flip each degree by window size

for i in range(90):
    currIndex = i*w
    endIndex = currIndex + w
    currentSlice = r_kernels[:,:,:,currIndex:endIndex]
    flippedSlice = np.flip(currentSlice,axis=3)
    r_kernels[:,:,:,currIndex:endIndex] = flippedSlice



print(f_kernels.shape)
# for i in range(0,f_kernels.shape[-1],w):
#     temp = f_kernels[:,:,:,i:i+w]
#     temp1 = temp[:,:,:,::-1]
#     f_kernels[:,:,:,i:i+w] = temp1
r_kernels = np.concatenate((r_kernels[:,:,:,w:-w],f_kernels),axis=3)
print(r_kernels.shape)
# r_kernels = r_kernels[:,:,:,w:]
# print(r_kernels.shape)
# Placeholders
conv2d_in = tf.placeholder(tf.float32, shape=(None, None, None, None))
# grad = tf.image.image_gradients(conv2d_in)
filter_2d = tf.placeholder(tf.float32, shape=(None, None, None, None))

img = tf.placeholder(tf.float32, shape=(None, None, None, None))
grad = tf.image.image_gradients(img)

grad_ratio = tf.placeholder(tf.float32, shape=(None, None, None, None))
ang = tf.atan(grad_ratio)

# filter_3d = tf.placeholder(tf.float32, shape=(None, None, None, None, None))
# Operations
conv_2d = tf.nn.conv2d(conv2d_in, filter_2d, strides=(1, 1, 1, 1), padding='VALID')
#this one calculate angle in a same shape as the original image i.e. (512,512)
#file_paths = glob.glob('D://validation//*.tif')
print("---Kernel Start Time:  %s seconds ---" % (time.time() - kernelStart_time))


#file_paths = glob.glob('D://validation//*.tif')
file_paths = glob.glob('C://Users//mbabaie//Documents//Derin//*.tif')


#TODO: HARDCODED??
image_height = 512
image_width = 512
pad = 5

bs = 1
# radon = np.zeros((1,image_height,image_width,r_kernels.shape[-1]//w))
# elp = np.zeros((image_height,image_width))



############## DERIN'S INITIALIZATION CODE ##############

folderPath = sys.argv[1]
print(folderPath)
file_paths = glob.glob(folderPath + '//*.tif')
detachFlag = False #If False, bins are up to 256 for histogram, otherwise its up to 1024

numBins = 256

if len(sys.argv) > 2:
    if sys.argv[2] > 0:
        detachFlag = True
        numBins = 1024



#########################################################




with tf.Session() as sess:
    images = np.asarray([rgb2gray(imread(file).astype('float32')/255.) for file in file_paths])
    print("Number of images: ",len(images))

    ################# DERIN'S CODE ##################
    outputArray = np.zeros((len(images), numBins))
    #################################################



    for i in range(0, len(file_paths), bs):
        print("Started")
        start_time = time.time()
        pad_imgs = np.pad(images[i],(pad,pad),mode='constant',constant_values=(0,0)).reshape((1,image_height+2*pad,image_width+2*pad,1))
        projs = sess.run(conv_2d, feed_dict={conv2d_in: pad_imgs, filter_2d: r_kernels})
        
        imgs = images[i].reshape((1,image_height,image_width,1))
        img_grad = sess.run(grad, feed_dict={img: imgs})
        angle = np.degrees(sess.run(ang, feed_dict={grad_ratio: np.true_divide(img_grad[1],img_grad[0]+2.22045e-16)}))
        
        print("--- %s seconds ---" % (time.time() - start_time))
        
        
        #####################################################################################################
        ############################### ---- DERIN'S CODE STARTS BELOW ------ ###############################
    
        # Maybe faster to somehow accomplish this read earlier (however this takes about 0.001 seconds when last checked)
        IMG = cv2.imread(file_paths[i], cv2.IMREAD_GRAYSCALE)

        print(IMG.shape)

        # Calculates the gradient array of the image. A different arctan function might make this faster.
        sobelx = cv2.Sobel(IMG, cv2.CV_32F, 1, 0, ksize=3, borderType=cv2.BORDER_REPLICATE)
        sobely = cv2.Sobel(IMG, cv2.CV_32F, 0, 1,ksize=3, borderType=cv2.BORDER_REPLICATE)
        Gdir = np.arctan2((-1)*sobely, sobelx) * 180/(np.pi) ##CAN PERHAPS OPTIMIZE THIS WITH A DIFFERENT arctan FUNCTION (ie OpenCV atan?)
        

        #MEDIAN BLUR
        #    medianArr = numpy.round(cv2.medianBlur(Gdir, 5)) # Patches are 11x11
        medianArr = cv2.medianBlur(Gdir, 5) # 5 here is harcoded (windowSize is 11)

        print("--- %s seconds ---" % (time.time() - start_time))

        rows = len(medianArr)
        cols = len(medianArr[0])

        #Get radonTensor

        bins = collections.OrderedDict()

        # Initialize the histogram
        numBins = 256
        if detachFlag:
            numBins = 1024


        for m in range(numBins):
            bins[m] = 0


        t = time.time()
        for row in range(rows):
            for col in range(cols):
                radonArr = getRadon(projs, medianArr[row, col], row, col, 11) # 11 (windowSize) is hardcoded

                radonVals = doubleGradBinarize(radonArr, 10) #10 is hardcoded (windowSize is 11 here)

                addToBins(bins, radonVals, detachFlag)

        print("--- %s seconds ---" % (time.time() - start_time))

        l1 = list(bins.values())
        outputArray[i] = l1

np.save('histograms.npy', outputArray)



import tensorflow as tf

tf.reset_default_graph()


# compare 5 degrees, 55 degrees, 140 degrees with the matlab order